Fix definition of ARRAY_SIZE for non-gcc builds
authorCharles Bailey <cbailey32@bloomberg.net>
Wed, 24 Jun 2015 22:12:07 +0000 (23:12 +0100)
committerJunio C Hamano <gitster@pobox.com>
Thu, 25 Jun 2015 00:14:00 +0000 (17:14 -0700)
commite2c6f7cd5a66ed0009662d2651e0cf3c655e83a9
treec79b499b4fe40cb26c4d8b78e920f6e60b709432
parent89c855ed3cbe64bea93ea081d0e96077e9ee8517
Fix definition of ARRAY_SIZE for non-gcc builds

The improved ARRAY_SIZE macro uses BARF_UNLESS_AN_ARRAY which expands
to a valid check for recent gcc versions and to 0 for older gcc
versions but is not defined on non-gcc builds.

Non-gcc builds need this macro to expand to 0 as well. The current outer
test (defined(__GNUC__) && (__GNUC__ >= 3)) is a strictly weaker
condition than the inner test (GIT_GNUC_PREREQ(3, 1)) so we can omit the
outer test and cause the BARF_UNLESS_AN_ARRAY macro to be defined
correctly on non-gcc builds as well as gcc builds with older versions.

Signed-off-by: Charles Bailey <cbailey32@bloomberg.net>
Signed-off-by: Junio C Hamano <gitster@pobox.com>
git-compat-util.h